'-------------------------------------------------------------------------------
' FBClient.bas - simple chat server client
'
' The socket is activated as non-blocking but ONLY the FD_CLOSE event generates
' a WndProc Msg (to detect server drop-out). The remainder of the code is made
' simple by use of the "polling" methods as per a blocking socket.
'
' To make use of all the windProc Msg events, you will need to activate them by calling:
' WSAAsyncSelect() function with lParam of (FD_CONNECT OR FD_READ OR FD_WRITE OR FD_CLOSE)
' THEN ... add your dispatch code in the existing Form1 WndProc.
'
' FreeBasic code generated by RapidFRM v1.61
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QSOCKET
#INCLUDE ONCE "win/winsock.bi"
#INCLUDE "win/RQInclude.bi"

'
' Some Global socket stuff
'
#DEFINE SERVER_ADDR "192.168.0.6"
#DEFINE SERVER_PORT 5000

DIM SHARED AS integer MainSock

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QLISTBOX ListBox1
DIM SHARED AS QLISTBOX PTR lpListBox1 = @ListBox1
DIM SHARED AS QEDIT Edit1
DIM SHARED AS QEDIT PTR lpEdit1 = @Edit1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QBUTTON Butn2
DIM SHARED AS QBUTTON PTR lpButn2 = @Butn2
DIM SHARED AS QBUTTON Butn3
DIM SHARED AS QBUTTON PTR lpButn3 = @Butn3
DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer1 = @Timer1
DIM SHARED AS QSOCKET Socket1
DIM SHARED AS QSOCKET PTR lpSocket1 = @Socket1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB SendData(Sender AS QBUTTON)
DECLARE SUB DoConnect(Sender AS QBUTTON)
DECLARE SUB DoExit(Sender AS QBUTTON)
DECLARE SUB DoTimer(Sender AS QTIMER)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Width = 400
    lpForm1->Height = 300
    lpForm1->Caption = "FB Client"

    lpListBox1->ObjIndex = 1
    lpListBox1->Left = 10
    lpListBox1->Top = 10
    lpListBox1->Width = 370
    lpListBox1->Height = 180
    lpListBox1->Parent = Form1.Handle

    lpEdit1->ObjIndex = 2
    lpEdit1->Left = 10
    lpEdit1->Top = 200
    lpEdit1->Width = 280
    lpEdit1->Parent = Form1.Handle

    lpButn1->ObjIndex = 3
    lpButn1->Enabled = False
    lpButn1->Left = 299
    lpButn1->Top = 201
    lpButn1->Height = 20
    lpButn1->Caption = "Send"
    lpButn1->Parent = Form1.Handle
    lpButn1->OnClick = CAST(ANY PTR, @SendData)

    lpButn2->ObjIndex = 4
    lpButn2->Left = 60
    lpButn2->Top = 240
    lpButn2->Caption = "Connect"
    lpButn2->Parent = Form1.Handle
    lpButn2->OnClick = CAST(ANY PTR, @DoConnect)

    lpButn3->ObjIndex = 5
    lpButn3->Left = 240
    lpButn3->Top = 240
    lpButn3->Caption = "EXIT"
    lpButn3->Parent = Form1.Handle
    lpButn3->OnClick = CAST(ANY PTR, @DoExit)

    lpTimer1->ObjIndex = 6
    lpTimer1->Interval = 250
    lpTimer1->OnTimer = CAST(ANY PTR, @DoTimer)

    lpSocket1->ObjIndex = 7
    lpSocket1->Parent = Form1.Handle
    lpSocket1->Protocol = IPPROTO_TCP
END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB AddChildObjects
DIM AS UINT StdStyle, ExtStyle
DIM AS string ObjCaption

    lpListBox1->PreSetConfig()
    ObjCaption=""
    lpListBox1->Parent=lpForm1->Handle
    StdStyle=lpListBox1->objStyle
    IF lpListBox1->Visible THEN StdStyle += WS_VISIBLE
    IF lpListBox1->BorderStyle=bsNone THEN ExtStyle=0 ELSE ExtStyle=WS_EX_CLIENTEDGE

    lpListBox1->Handle=CreateWindowEx(ExtStyle,lpListBox1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpListBox1->Left, lpListBox1->Top, lpListBox1->Width, lpListBox1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpListBox1->objIndex), 0, 0)

    lpListBox1->PostConfig()
    EnableWindow(lpListBox1->Handle, lpListBox1->Enabled)

    lpEdit1->PreSetConfig()
    ObjCaption=""
    lpEdit1->Parent=lpForm1->Handle
    StdStyle=lpEdit1->objStyle
    IF lpEdit1->Visible THEN StdStyle += WS_VISIBLE
    IF lpEdit1->BorderStyle=bsNone THEN ExtStyle=0 ELSE ExtStyle=WS_EX_CLIENTEDGE

    lpEdit1->Handle=CreateWindowEx(ExtStyle,lpEdit1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpEdit1->Left, lpEdit1->Top, lpEdit1->Width, lpEdit1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpEdit1->objIndex), 0, 0)

    lpEdit1->PostConfig()
    EnableWindow(lpEdit1->Handle, lpEdit1->Enabled)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    lpButn1->Parent=lpForm1->Handle
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpButn2->PreSetConfig()
    ObjCaption=lpButn2->Caption
    lpButn2->Parent=lpForm1->Handle
    StdStyle=lpButn2->objStyle
    IF lpButn2->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=0

    lpButn2->Handle=CreateWindowEx(ExtStyle,lpButn2->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn2->Left, lpButn2->Top, lpButn2->Width, lpButn2->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn2->objIndex), 0, 0)

    lpButn2->PostConfig()
    EnableWindow(lpButn2->Handle, lpButn2->Enabled)

    lpButn3->PreSetConfig()
    ObjCaption=lpButn3->Caption
    lpButn3->Parent=lpForm1->Handle
    StdStyle=lpButn3->objStyle
    IF lpButn3->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=0

    lpButn3->Handle=CreateWindowEx(ExtStyle,lpButn3->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn3->Left, lpButn3->Top, lpButn3->Width, lpButn3->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn3->objIndex), 0, 0)

    lpButn3->PostConfig()
    EnableWindow(lpButn3->Handle, lpButn3->Enabled)

    lpTimer1->Parent=lpForm1->Handle
    SetTimer(lpForm1->Handle, lpTimer1->ObjIndex, lpTimer1->Interval, 0)
END SUB

'-------------------------------------------------------------------------------
' Load components
'-------------------------------------------------------------------------------
SUB LoadComponents
    SendMessage(Application.hMainForm, WM_LOAD_COMPONENTS, 0, 0)
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer1->Enabled=False
    KillTimer(lpForm1->Handle, lpTimer1->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)

    Application.hWndTTip=CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, "", _
                                    WS_POPUP OR TTS_NOPREFIX OR TTS_ALWAYSTIP, _
                   CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
                                                                Parent, 0, 0, 0)
    SetWindowPos(Application.hWndTTip, HWND_TOPMOST, 0, 0, 0, 0, _
                                      SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt
DIM AS integer ShowIt=False

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                    ShowIt=True
                END IF
            CASE lpListBox1->Handle
                IF lpListBox1->ShowHint THEN
                    SysDisplayHint(lpListBox1->Handle, lpListBox1->Hint)
                    ShowIt=True
                END IF
            CASE lpEdit1->Handle
                IF lpEdit1->ShowHint THEN
                    SysDisplayHint(lpEdit1->Handle, lpEdit1->Hint)
                    ShowIt=True
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                    ShowIt=True
                END IF
            CASE lpButn2->Handle
                IF lpButn2->ShowHint THEN
                    SysDisplayHint(lpButn2->Handle, lpButn2->Hint)
                    ShowIt=True
                END IF
            CASE lpButn3->Handle
                IF lpButn3->ShowHint THEN
                    SysDisplayHint(lpButn3->Handle, lpButn3->Hint)
                    ShowIt=True
                END IF
        END SELECT
        IF (ShowIt=False) AND (Application.hWndTTip <> 0) THEN
            DestroyWindow(Application.hWndTTip)
            Application.hWndTTip=0
        END IF
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------
SUB CheckWmCommandMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpListBox1->ObjIndex
            IF HIWORD(wParam)=LBN_SELCHANGE THEN
                IF lpListBox1->OnClick>0 THEN lpListBox1->OnClick(lpListBox1)
            END IF
            IF HIWORD(wParam)=LBN_DBLCLK THEN
                IF lpListBox1->OnDblClick>0 THEN lpListBox1->OnDblClick(lpListBox1)
            END IF
        CASE lpEdit1->ObjIndex
            IF lpEdit1->OnChange>0 THEN lpEdit1->OnChange(lpEdit1)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE lpButn2->ObjIndex
            IF lpButn2->OnClick>0 THEN lpButn2->OnClick(lpButn2)
        CASE lpButn3->ObjIndex
            IF lpButn3->OnClick>0 THEN lpButn3->OnClick(lpButn3)
    END SELECT
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
        CASE lpTimer1->ObjIndex
            IF lpTimer1->OnTimer>0 THEN lpTimer1->OnTimer(lpTimer1)
    END SELECT
END SUB

SUB CheckWmNotifyMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
' Server: Only ONE message of interest FD_ACCEPT (Server socket ALWAYS non-blocking mode)
' Client: ONLY if YOU set the socket to asynch (non-blocking) the remainder of messages
' NB The wParam is the socket descriptor (handle)
    IF HIWORD(lParam)<>0 THEN
        lpSocket1->SockError=WSAGetLastError()
        EXIT SUB
    END IF
    SELECT CASE lParam
        CASE FD_ACCEPT
            lpSocket1->ConnPending=True                ' Remote connection request
        CASE FD_CONNECT                                '|
        CASE FD_READ                                   '| Client socket asynch mode,...
        CASE FD_WRITE                                  '| ...add your dispatch code here
        CASE FD_CLOSE                                  '|
            lpSocket1->DiscPending=wParam              ' Remote disconnection
    END SELECT
END SUB

FUNCTION WndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    
    SELECT CASE wMsg
        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(hWnd, wMsg, wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_NOTIFY
            CheckWmNotifyMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->OnMouseMove>0 THEN lpForm1->OnMouseMove(LOWORD(lParam), _
                                                            HIWORD(lParam), 0, lpForm1)
        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_CREATE

        CASE WM_LOAD_COMPONENTS
            AddChildObjects
            InitSystemTimers(hWnd)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_CLOSE
            DIM AS integer Action=1                                      ' Default Action is quit
            IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
            IF Action=0 THEN RETURN 0                                    ' user can change default action

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' WndProc hooks for additional components
'-------------------------------------------------------------------------------
'
' ***Add additional WndProcs as required***
'

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS MSG wMsg

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @WndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = Cast(HBRUSH, COLOR_WINDOW)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    IF RegisterClassEx(@wc) = 0 THEN
        ShowMessage("Register class error")
        RETURN 0
    END IF

    lpForm1->Parent = 0
    lpForm1->Handle = CreateWindowEx(0, "RQClass", lpForm1->Caption, _
                    WS_OVERLAPPEDWINDOW, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, hInst, 0)
    Application.hMainForm = lpForm1->Handle

    ' You may wish to delete the following line
    lpForm1->Center

    ' Load remainder of components
    ConfigureComponents()
    LoadComponents()

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)
    ShowWindow(lpForm1->Handle, SW_SHOW)

    HookTheMouse()
'
'   The following loop is the equivalent of a "Form.ShowModal"
'
    WHILE GetMessage(@wMsg, NULL, 0, 0) <> FALSE
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND

    UnHookTheMouse()

    RETURN wMsg.wParam
END FUNCTION
'
' Main Entry Point
'
END WinMain(Application.hInstance, NULL, Command(), SW_NORMAL)

'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB DoConnect(Sender AS QBUTTON)
    ListBox1.Clear
    MainSock=Socket1.sktConnect(SERVER_ADDR, SERVER_PORT)
    IF MainSock=0 THEN
        ListBox1.AddItems "Failed to connect!"
    ELSE
        DIM AS string tstr=Socket1.GetHostName()+" connected to server"
        ListBox1.AddItems tstr
        Butn1.Enabled = True                 ' Enable Send btn
        Butn2.Enabled = False                ' Disable Connect btn
    END IF
END SUB

' NB RQ func WriteLine() ALWAYS adds a NewLine char at end of string
SUB SendData(Sender AS QBUTTON)
DIM AS string tstr=lpEdit1->Text

    IF Socket1.WriteLine(MainSock, tstr)>0 THEN
        ListBox1.AddItems "TX: "+tstr
    ELSE
        ListBox1.AddItems "Server disconnected!"
        Socket1.sktClose(MainSock)
        Butn2.Enabled = True                 ' Enable the Connect btn
    END IF
END SUB

' NB RQ func ReadLine() ONLY returns on the reception of a NewLine char!!
SUB DoTimer(Sender AS QTIMER)
DIM AS string tstr

    IF MainSock>0 THEN
        IF Socket1.DiscPending THEN
            Socket1.DiscPending=0
            Socket1.sktClose(MainSock)
            MainSock=0
            ListBox1.AddItems "Server disconnected!"
            Butn2.Enabled = True                 ' Enable the Connect btn
        ELSE
            IF Socket1.IsServerReady(MainSock)>0 THEN
                tstr=Socket1.ReadLine(MainSock)
                ListBox1.AddItems "RX: "+LEFT(tstr,LEN(tstr)-1)  ' Remove NewLine char
            END IF
        END IF
    END IF
END SUB

SUB DoExit(Sender AS QBUTTON)
    IF MainSock>0 THEN Socket1.sktClose(MainSock)
    Application.Terminate
END SUB

